<?php
require_once('oauth_conf.php');
session_start();
if (!isset($_SESSION['acsToken']) || !isset($_SESSION['acsTokenSecret'])) {
  header('Location: /wdpress/63/2/');
  exit();
}

$oauth = new OAuth($conf['consKey'],$conf['consSecret']);
$oauth->setToken($_SESSION['acsToken'], //...(1)
                 $_SESSION['acsTokenSecret']);

// ツイートを投稿 ...(2)
$status = 'WEB+DB PRESS Vol.63 なう。http://bit.ly/webdbpress';
$oauth->fetch('https://api.twitter.com/1/statuses/update.json',
              array('status' => $status),
              OAUTH_HTTP_METHOD_POST);

// @gihyojp をフォロー ...(3)
$oauth->fetch('https://api.twitter.com/1/friendships/create.json',
              array('screen_name' => 'gihyojp',
                    'follow' => 'true'),
              OAUTH_HTTP_METHOD_POST);

// 自分のタイムラインを取得 ...(4)
$oauth->fetch('https://api.twitter.com/1/statuses/user_timeline.json',
              array('screen_name' => $_SESSION['userName']),
              OAUTH_HTTP_METHOD_GET);
$timeline = json_decode($oauth->getLastResponse()); //...(5)

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
 "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ja" lang="ja">
<head>
<meta http-equiv="Content-Type" content="text/html;charset=utf-8" />
<meta http-equiv="Content-Script-Type" content="text/javascript" />
<meta http-equiv="Content-Style-Type" content="text/css" />
<title>2章 Twitter連携アプリケーションを作ろう | WEB+DB PRESS Vol.63 作って学ぶOAuth認証 サンプル</title>

<link rel="stylesheet" type="text/css" href="http://yui.yahooapis.com/3.3.0/build/cssreset/reset-min.css" />
<link rel="stylesheet" type="text/css" href="../style.css" />
</head>
<body class="chapter_page">

<h1 id="FeatureTitle"><span class="vol">WEB+DB PRESS Vol.63</span><br />作って学ぶOAuth認証 サンプル</h1>
<h2 id="ChapterTitle">2章　Twitter連携アプリケーションを作ろう 〜 OAuth 1.0 コンシューマの実装 〜</h2>

<h3 id="MyProfile" class="clearfix">
    <img width="48" height="48" src="<?php echo htmlspecialchars($timeline[0]->user->profile_image_url); ?>" />
    <div>
        <a href="http://twitter.com/#!/<?php echo htmlspecialchars($timeline[0]->user->screen_name); ?>">@<?php echo htmlspecialchars($timeline[0]->user->screen_name); ?></a></br />
        <?php echo htmlspecialchars($timeline[0]->user->name); ?>
    </div>
</h3>

<ol id="Tweets" class="twitter"><?php foreach($timeline as $s): ?>
<li>
<p class="tweet_text"><?php echo htmlspecialchars($s->text); ?></p>
<p class="date"><?php $d = new DateTime($s->created_at); $d->setTimezone(new DateTimeZone("Asia/Tokyo")); echo $d->format("Y/m/d H:i:s");
?></p>
</li>
<?php endforeach; ?></ol>


<div id="Footer">
    <a href="../">&laquo; サンプルインデックスに戻る</a>
</div>
</body>
</html>
