<?php
session_start();

/* ※連携するWebサービスによって読み込む oauth_conf.php とスコープを分けてあります。 */
$service = $_SESSION['service'];
if ($service == 'mixi') {
    require_once('oauth_conf_mixi.php');
} elseif ($service == 'facebook') {
    require_once('oauth_conf_fb.php');
} else {
    require_once('oauth_conf_chapter4.php');
}

if (isset($_GET['error'])) { // 認可が拒否された場合
    header('Location: /wdpress/63/3/');
    exit();
}

$params = array(
  'client_id'     => $conf['consKey'],
  'client_secret' => $conf['consSecret'],
  'redirect_uri'  => $conf['callbackUrl'],
  'code'          => $_GET['code'],
  'grant_type'    => 'authorization_code'
);

// アクセストークンURLにPOST
$response = doPost($conf['acsTokenUrl'], $params);

if (in_array($service, array('mixi', 'chapter4'))) { // ※mixi、4章のサンプルの場合

    $data = json_decode($response);
    $acsToken = $data->access_token; 
    $_SESSION['acsToken'] = $acsToken;
    header(sprintf('Location: result_%s.php', $service));

} else { // ※Facebookの場合

    $data = array();
    parse_str($response, $data);
    $acsToken = $data['access_token'];
    $_SESSION['acsToken'] = $acsToken;
    header('Location: result_fb.php');

}

?>
