<?php
require('common.inc');

$clientId     = $_GET['client_id'];
$redirectUri  = $_GET['redirect_uri'];
$responseType = $_GET['response_type'];
$scope        = $_GET['scope'];

/**
 * ユーザがサービスプロバイダのサービスにログインしているか
 * 判定します。
 *
 * @return boolean ログインしている場合 true
 */
function isLoggedIn() {
  // サンプルでは常にログインしているとみなす
  return isset($_SESSION['userInfo']);
}

/**
 * 有効なスコープかどうか判定します。
 *
 * @param string $scope スペース区切りのスコープ
 * @return boolean 有効なスコープの場合 true
 */
function isValidScope($scope) {
  foreach (explode(' ', $scope) as $s) {
    if (!in_array($s, array('w_voice', 'r_updates'))) {
      return false;
    }
  }
  return true;
}

if (!isset($clientsData[$clientId])) {
  redirectToCallbackUri($redirectUri, array(
    'error' => 'invalid_client',
  ));
} else if (!isValidScope($scope)) {
  redirectToCallbackUri($redirectUri, array(
    'error' => 'invalid_scope',
  ));
} else if ($responseType !== 'code') {
  redirectToCallbackUri($redirectUri, array(
    'error' => 'unsupported_response_type',
  ));
} else {
  session_start();
  $_SESSION['authInfo'] = $_GET;

  if (isLoggedIn()) {
    // 認可ページを表示
    include('auth.tmpl');
  } else {
    // ログインページを表示
    include('login.tmpl');
  }
}
exit();
?>
