<?php

// アプリケーション登録コンシューマのデータ
// 連想配列のキーはコンシューマキー
$clientsData = array(
  'f4f838e40e179a6be94b' => array(
    'secret' => '8efe20f011b05fa46d8d8b222e41427ff6de024a',
    'appName' => 'WEB+DB PRESS Vol.63 サンプル',
  ),
);

// サービスプロバイダの登録ユーザのデータ
// 連想配列のキーはユーザID
$usersData = array(
  'kimurafumino' => array(
    'name'     => '木村文乃',
    'password' => md5('chifure'),
  ),
);

// 有効なスコープの定義

// データストアとして使うMemcachedサーバに接続
$memcache = new Memcache();
$memcache->connect('localhost', 11211);

/**
 * 連想配列のデータをJSONフォーマットで出力します。
 *
 * @param array $data
 */
function outputJsonResponse($params) {
  header("Content-Type: application/json");
  header("Cache-Control: no-store");
  echo json_encode($params);
}

/**
 * @param string $scope 認可されたスコープリスト。スペース区切り
 * @param string $requiredScope 要求スコープ
 * @return boolean
 */
function isAuthorizedScope($scope, $requiredScope) {
  foreach(explode(' ', $scope) as $s) {
    if ($s === $requiredScope) {
      return true;
    }
  }
  return false;
}

/**
 * @param string $uri コンシューマのコールバックURI
 * @param string $parameters 
 */
function redirectToCallbackUrl($url, $params, $state=null) {
  if (!is_null($state)) {
    array_push_array($params, array('state' => $state));
  }
  $u = parse_url($url);
  $result = $u['scheme'] . '://' . $u['host'] . $u['path'];
  if (isset($u['query'])) {
    $result .= '&' . http_build_query($params);
  } else {
    $result .= '?' . http_build_query($params);
  }
  if (isset($u['fragment'])) {
    $result .= '#' . $u['fragment'];
  }
  header('Location: ' . $result);
  exit();
}

