<?php
require('common.inc');
if ($_SERVER['REQUEST_METHOD'] != 'POST') {
  header('HTTP/1.0 405 Method Not Allowed', false);
  exit();
}

$clientId     = $_POST['client_id'];
$clientSecret = $_POST['client_secret'];
$redirectUri  = $_POST['redirect_uri'];
$grantType    = $_POST['grant_type'];

if (!isset($clientsData[$clientId]) ||
    $clientsData[$clientId]['secret'] != $clientSecret) {

  outputJsonResponse(array(
    'error' => 'invalid_client',
  ));
  exit();
}

if ($grantType == 'authorization_code') {
  $code     = $_POST['code'];
  $authInfo = $memcache->get('CODE_' . $code);
  if ($authInfo && $authInfo['redirect_uri'] == $redirectUri) {
    $memcache->delete($code);

    $acsToken     = uniqid(); // アクセストークンを生成
    $refreshToken = uniqid(); // リフレッシュトークン生成
    $memcache->add('TOKEN_' . $acsToken, $authInfo, false, 900);
    $memcache->add('REFLESH_' . $refreshToken, $authInfo, false, 3600);

    $res = array(
      'access_token'  => $acsToken,
      'refresh_token' => $refreshToken,
      'expires_in'    => 900,
    );
    outputJsonResponse($res);
  } else {
    outputJsonResponse(array(
      'error' => 'invalid_grant',
    ));
  }
} elseif ($grantType == 'refresh_token') {
  $refreshToken = $_POST['refresh_token'];
  $authInfo = $memcache->get('REFRESH_' . $refreshToken);
  if ($authInfo && $authInfo['redirect_uri'] == $redirectUri) {
    $acsToken = uniqid(); // アクセストークンを生成
    $memcache->add('TOKEN_' . $acsToken, $authInfo, false, 900);
    $memcache->add('REFLESH_' . $refreshToken, $authInfo, false, 3600);
    $res = array(
      'access_token'  => $acsToken,
      'refresh_token' => $refreshToken,
      'expires_in'    => 900,
    );
    outputJsonResponse($res);
  } else {
    outputJsonResponse(array(
      'error' => 'invalid_grant',
    ));
  }
} else {
  outputJsonResponse(array(
    'error' => 'unsupported_grant_type',
  ));
}

exit();
?>
