<?php
require('common.inc');

if ($_SERVER['REQUEST_METHOD'] != 'POST') {
  header('HTTP/1.0 405 Method Not Allowed', false);
  exit();
}

$acsToken = $_REQUEST['oauth_token'];
$status   = $_POST['status'];

function updateStatus($userId, $status) {
  global $memcache;
  $key = 'STATUS_' . $userId;
  $tweets = $memcache->get($key);
  if (!$tweets) $tweets = array();
  $tweets[] = array('time' => time(), 'status' => $status);
  $memcache->set($key, $tweets);
  return $tweets;
}

$authInfo = $memcache->get('TOKEN_' . $acsToken);
if ($authInfo) {
  $scope = $authInfo['scope'];
  if (isAuthorizedScope($scope, 'w_voice')) {
    $userId = $authInfo['userId'];
    $tweets = updateStatus($userId, $status);
    outputJsonResponse(array('items' => $tweets));
  } else {
    header('HTTP/1.0 403 Forbidden', false);
    header('WWW-Authentication: OAuth error=\'insufficient_scope\'');
  }
} else {
  header('HTTP/1.0 401 Unauthorized', false);
  header('WWW-Authentication: OAuth error=\'expired_token\'');
}
exit();
?>
